Subject: Re: DSA and underlying 802.1Q encapsulation

From: Guenter Roeck <[email-masked]>
Date: Thu, 28 May 2015 07:19:43 -0700

On 05/28/2015 06:44 AM, Vivien Didelot wrote:
> Hi Guenter,
>
>>>> If yes, the dsa code may need to move the tag into the header.
>>>> If we are lucky, a call to vlan_hwaccel_push_inside() might do it.
>>>
>>> Thanks, I'm currently looking into it and doing some tests, I'm coming back to
>>> you asap.
>
> Issue fixed, thanks! vlan_hwaccel_push_inside() adds additional memmove, but
> this approach is simpler.
>
>>>> Do you have some vlan dsa code to share, by any chance ? That might
>>>> save me some time, as I am looking into it as well.
>>>
>>> Yes, I am about the send an RFC for fully integrated 802.1q VLAN support on
>>> Marvell 88E6352 devices.
>>>
>> Excellent, that is going to safe me a lot of work! If you don't mind,
>> please Cc: me as I am not subscribed to the network mailing list.
>
> My work is based on v4.1-rc3. Unfortunately the VLAN support breaks on latest
> net-next/master (e.g. NETIF_F_HW_SWITCH_OFFLOAD is removed; .ndo_bridge_setlink
> used to set tag and PVID, is moved to switchdev.)
>
> Are you willing to give it a try based on v4.1-rc3 in the meantime?
> Otherwise, I'll send the RFC as soon as the support is functional on net-next.
>

I already rebased my code to net-next, not for the switchdev changes but
to catch the dsa changes, so net-next would be much better. I'd like to get
a glance at your code, though, if that is possible.

Thanks,
Guenter